;;
;; strtoqw - conversion of C library strtoll from the WCRT library to MASM.
;;
;; Copyright (c) 2004 by Joergen Ibsen / Jibz
;; All Rights Reserved
;;
;; http://www.ibsensoftware.com/
;;

; Listing generated by Microsoft (R) Optimizing Compiler Version 13.10.3052

.386
.model flat

option casemap:none

public _strtoqw@12

.code

_strtoqw@12:

    _negative$ = 8
    _s$        = 8
    _endp$     = 12
    _base$     = 16

    push   ebp
    push   edi

    mov    edi, _s$[esp+4]

    mov    al, [edi]
    xor    ecx, ecx
    xor    ebp, ebp
    test   al, al
    mov    _negative$[esp+4], ecx
    je     return_zero

  @@:
    cmp    al, ' '
    ja     found_first_char
    mov    al, [edi+1]
    inc    edi
    test   al, al
    jne    @B

    ; found nothing, so return zero

  return_zero:
    mov    eax, _endp$[esp+4]
    cmp    eax, ecx
    je     @F
    mov    [eax], edi

  @@:
    pop    edi
    xor    eax, eax
    xor    edx, edx
    pop    ebp

    ret    12

  found_first_char:
    cmp    al, '+'
    je     found_sign
    cmp    al, '-'
    jne    sign_done

  found_sign:
    xor    edx, edx
    cmp    al, '-'
    sete   dl

    inc    edi
    mov    _negative$[esp+4], edx

  sign_done:
    push   ebx

    mov    ebx, _base$[esp+8]
    cmp    ebx, ecx
    jne    base_was_specified

    cmp    BYTE PTR [edi], '0'
    je     found_zero

    mov    ebx, 10            ; decimal

    jmp    base_done

  found_zero:
    mov    al, [edi+1]
    cmp    al, 'x'
    je     base_hex
    cmp    al, 'X'
    je     base_hex

    mov    ebx, 8             ; octal
    inc    edi

    jmp    base_done

  base_hex:
    mov    ebx, 16            ; hex

    jmp    base_done_skip_2

  base_was_specified:
    cmp    ebx, 16
    jne    base_done

    cmp    BYTE PTR [edi], '0'
    jne    base_done

    mov    al, [edi+1]
    cmp    al, 'x'
    je     base_done_skip_2
    cmp    al, 'X'
    jne    base_done

  base_done_skip_2:
    add    edi, 2

  base_done:
    mov    al, [edi]
    test   al, al
    je     set_endp_return
    push   esi

    db     8DH, 49H, 00H ; npad 3

  digit_loop:
    movzx  esi, al

    cmp    esi, 'a'
    jb     @F
    sub    esi, 'a'-'A'
  @@:
    cmp    esi, 'A'
    jb     @F

    sub    esi, 'A'-10

    jmp    got_digit

  @@:
    cmp    esi, '0'
    jb     digit_done
    cmp    esi, '9'
    ja     digit_done

    sub    esi, '0'

  got_digit:
    cmp    esi, ebx
    jae    digit_done

    mov    eax, ebx           ; replaced call to _allmul
    mul    ecx                ;
    mov    ecx, eax           ;
    mov    eax, ebx           ;
    mul    ebp                ;
    add    edx, ecx           ;

    xor    ecx, ecx
    add    eax, esi
    adc    edx, ecx
    inc    edi
    mov    ebp, eax
    mov    al, [edi]
    test   al, al
    mov    ecx, edx
    jne    digit_loop

  digit_done:
    pop    esi

  set_endp_return:
    mov    eax, _endp$[esp+8]
    test   eax, eax
    pop    ebx
    je     @F
    mov    [eax], edi

  @@:
    mov    eax, _negative$[esp+4]
    test   eax, eax
    je     @F
    neg    ebp
    adc    ecx, 0
    neg    ecx

  @@:
    pop    edi
    mov    eax, ebp
    mov    edx, ecx
    pop    ebp

    ret    12

end
